#!/usr/bin/env /usr/local/n/versions/node/8.4.0/bin/node
var fs 		=	require('fs');
var parseString =	require('xml2js').parseString;
var xml2js      =	require('xml2js');
var _		= 	require('underscore');
var rome_file = 'rome.xml';

'use strict';

const args = require('yargs').argv;

var vsxi_file=(args._[0]);  
var rome_file=(args._[0] + 'rome-carrier.xml');
console.log('File: ' + (args._[0]));  

if (fs.existsSync(vsxi_file)) { 
  var xml = fs.readFileSync(vsxi_file);
  var rome_json = { XBCarrierList: { XBCarrier: [] } };
  var index = 0;
  var maxTID = 0;
  parseString(xml, function (err, result) {
  maxTID = result.XBCarrierTIDList.XBCarrierTID.length;
    console.dir(JSON.stringify(result));
    console.log("Successfully parsed XML file");
    
    _.each(result.XBCarrierTIDList.XBCarrierTID, function(trunk) {
     var tidcounter = 0;
     var mapentry= {};
       console.log(JSON.stringify(trunk));
       mapentry.carrierID= trunk.trunkID;
       mapentry.carrierType= "Both";
       mapentry.routeTableGroupID = "1";
       mapentry.totalTrunk = "0";
       mapentry.serviceLevel = "1";
       mapentry.policy = "Round Robin";
       mapentry.status = "Block None";
       mapentry.rnRouteLookUp = "enable";
       mapentry.aniInputOrderProfileId = "1";
       mapentry.carrierRoutingType = "Standard Route Tables";
       mapentry.percentageOfCost = "0";
       mapentry.companyName = trunk.alias;
       mapentry.mainContactName = "";
       mapentry.streetAddress = "";
       mapentry.city = "";
       mapentry.state = "";
       mapentry.country = "";
       mapentry.zipCode = "";
       mapentry.email = "";
       mapentry.phone = "";
       mapentry.mobilePhone = "";
       mapentry.fax = "";
       mapentry.customerRateTableID = "1";
       mapentry.maxRoutes = "12";


       rome_json.XBCarrierList.XBCarrier.push(mapentry);
       index++;
    });

 });
  setInterval(function(){
    if (index === maxTID) {
      console.log("DONE!");
      console.dir(rome_json);
      console.dir(JSON.stringify(rome_json));
      var builder = new xml2js.Builder();
      var xml = builder.buildObject(rome_json);

      console.dir(xml);
      console.log(rome_file); 
      fs.writeFile(rome_file, xml, function(err, data) {
        if (err) console.log(err);
        console.log("Successfully Written to File.");
        process.exit(1);
      });

      return 1;

    }
  }, 2000);

} else {
  console.log("File doesn't exist...");
  return -1;
}



